const utd = require('../src/index');

const testString = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';

const correctAnswerCapital = {
    bold_serif: "𝐀𝐁𝐂𝐃𝐄𝐅𝐆𝐇𝐈𝐉𝐊𝐋𝐌𝐍𝐎𝐏𝐐𝐑𝐒𝐓𝐔𝐕𝐖𝐗𝐘𝐙",
    italic_serif: '𝐴𝐵𝐶𝐷𝐸𝐹𝐺𝐻𝐼𝐽𝐾𝐿𝑀𝑁𝑂𝑃𝑄𝑅𝑆𝑇𝑈𝑉𝑊𝑋𝑌𝑍',
    bold_italic_serif: '𝑨𝑩𝑪𝑫𝑬𝑭𝑮𝑯𝑰𝑱𝑲𝑳𝑴𝑵𝑶𝑷𝑸𝑹𝑺𝑻𝑼𝑽𝑾𝑿𝒀𝒁',
    script: '𝒜ℬ𝒞𝒟ℰℱ𝒢ℋℐ𝒥𝒦ℒℳ𝒩𝒪𝒫𝒬ℛ𝒮𝒯𝒰𝒱𝒲𝒳𝒴𝒵',
    bold_script: '𝓐𝓑𝓒𝓓𝓔𝓕𝓖𝓗𝓘𝓙𝓚𝓛𝓜𝓝𝓞𝓟𝓠𝓡𝓢𝓣𝓤𝓥𝓦𝓧𝓨𝓩',
    fraktur: '𝔄𝔅ℭ𝔇𝔈𝔉𝔊ℌℑ𝔍𝔎𝔏𝔐𝔑𝔒𝔓𝔔ℜ𝔖𝔗𝔘𝔙𝔚𝔛𝔜ℨ',
    bold_fraktur: '𝕬𝕭𝕮𝕯𝕰𝕱𝕲𝕳𝕴𝕵𝕶𝕷𝕸𝕹𝕺𝕻𝕼𝕽𝕾𝕿𝖀𝖁𝖂𝖃𝖄𝖅',
    double_struck: '𝔸𝔹ℂ𝔻𝔼𝔽𝔾ℍ𝕀𝕁𝕂𝕃𝕄ℕ𝕆ℙℚℝ𝕊𝕋𝕌𝕍𝕎𝕏𝕐ℤ',
    sans_serif: '𝖠𝖡𝖢𝖣𝖤𝖥𝖦𝖧𝖨𝖩𝖪𝖫𝖬𝖭𝖮𝖯𝖰𝖱𝖲𝖳𝖴𝖵𝖶𝖷𝖸𝖹',
    bold_sans_serif: '𝗔𝗕𝗖𝗗𝗘𝗙𝗚𝗛𝗜𝗝𝗞𝗟𝗠𝗡𝗢𝗣𝗤𝗥𝗦𝗧𝗨𝗩𝗪𝗫𝗬𝗭',
    italic_sans_serif: '𝘈𝘉𝘊𝘋𝘌𝘍𝘎𝘏𝘐𝘑𝘒𝘓𝘔𝘕𝘖𝘗𝘘𝘙𝘚𝘛𝘜𝘝𝘞𝘟𝘠𝘡',
    bold_italic_sans_serif: '𝘼𝘽𝘾𝘿𝙀𝙁𝙂𝙃𝙄𝙅𝙆𝙇𝙈𝙉𝙊𝙋𝙌𝙍𝙎𝙏𝙐𝙑𝙒𝙓𝙔𝙕',
    monospace: '𝙰𝙱𝙲𝙳𝙴𝙵𝙶𝙷𝙸𝙹𝙺𝙻𝙼𝙽𝙾𝙿𝚀𝚁𝚂𝚃𝚄𝚅𝚆𝚇𝚈𝚉',
    regional_indicator: '🇦🇧🇨🇩🇪🇫🇬🇭🇮🇯🇰🇱🇲🇳🇴🇵🇶🇷🇸🇹🇺🇻🇼🇽🇾🇿',
    circle: 'ⒶⒷⒸⒹⒺⒻⒼⒽⒾⒿⓀⓁⓂⓃⓄⓅⓆⓇⓈⓉⓊⓋⓌⓍⓎⓏ',
    black_circle: '🅐🅑🅒🅓🅔🅕🅖🅗🅘🅙🅚🅛🅜🅝🅞🅟🅠🅡🅢🅣🅤🅥🅦🅧🅨🅩',
    square: '🄰🄱🄲🄳🄴🄵🄶🄷🄸🄹🄺🄻🄼🄽🄾🄿🅀🅁🅂🅃🅄🅅🅆🅇🅈🅉',
    parenthesized: '🄐🄑🄒🄓🄔🄕🄖🄗🄘🄙🄚🄛🄜🄝🄞🄟🄠🄡🄢🄣🄤🄥🄦🄧🄨🄩',
    fullwidth: 'ＡＢＣＤＥＦＧＨＩＪＫＬＭＮＯＰＱＲＳＴＵＶＷＸＹＺ',
};

test('bold_serif Capital', () => {
    expect(utd.decorate(testString, 'bold_serif')).toBe(correctAnswerCapital.bold_serif);
});



test('italic_serif Capital', () => {
    expect(utd.decorate(testString, 'italic_serif')).toBe(correctAnswerCapital.italic_serif);
});

test('bold_italic_serif Capital', () => {
    expect(utd.decorate(testString, 'bold_italic_serif')).toBe(correctAnswerCapital.bold_italic_serif);
});

test('script Capital', () => {
    expect(utd.decorate(testString, 'script')).toBe(correctAnswerCapital.script);
});

test('bold_script Capital', () => {
    expect(utd.decorate(testString, 'bold_script')).toBe(correctAnswerCapital.bold_script);
});

test('fraktur Capital', () => {
    expect(utd.decorate(testString, 'fraktur')).toBe(correctAnswerCapital.fraktur);
});

test('bold_fraktur Capital', () => {
    expect(utd.decorate(testString, 'bold_fraktur')).toBe(correctAnswerCapital.bold_fraktur);
});

test('double_struck Capital', () => {
    expect(utd.decorate(testString, 'double_struck')).toBe(correctAnswerCapital.double_struck);
});

test('sans_serif Capital', () => {
    expect(utd.decorate(testString, 'sans_serif')).toBe(correctAnswerCapital.sans_serif);
});

test('bold_sans_serif Capital', () => {
    expect(utd.decorate(testString, 'bold_sans_serif')).toBe(correctAnswerCapital.bold_sans_serif);
});

test('italic_sans_serif Capital', () => {
    expect(utd.decorate(testString, 'italic_sans_serif')).toBe(correctAnswerCapital.italic_sans_serif);
});