const utd = require('../src/index');

const testString = 'abcdefghijklmnopqrstuvwxyz';

const correctAnswerSmallWithFallBack = {
    bold_serif: "𝐚𝐛𝐜𝐝𝐞𝐟𝐠𝐡𝐢𝐣𝐤𝐥𝐦𝐧𝐨𝐩𝐪𝐫𝐬𝐭𝐮𝐯𝐰𝐱𝐲𝐳",
    italic_serif: '𝑎𝑏𝑐𝑑𝑒𝑓𝑔ℎ𝑖𝑗𝑘𝑙𝑚𝑛𝑜𝑝𝑞𝑟𝑠𝑡𝑢𝑣𝑤𝑥𝑦𝑧',
    bold_italic_serif: '𝒂𝒃𝒄𝒅𝒆𝒇𝒈𝒉𝒊𝒋𝒌𝒍𝒎𝒏𝒐𝒑𝒒𝒓𝒔𝒕𝒖𝒗𝒘𝒙𝒚𝒛',
    script: '𝒶𝒷𝒸𝒹ℯ𝒻ℊ𝒽𝒾𝒿𝓀𝓁𝓂𝓃ℴ𝓅𝓆𝓇𝓈𝓉𝓊𝓋𝓌𝓍𝓎𝓏',
    bold_script: '𝓪𝓫𝓬𝓭𝓮𝓯𝓰𝓱𝓲𝓳𝓴𝓵𝓶𝓷𝓸𝓹𝓺𝓻𝓼𝓽𝓾𝓿𝔀𝔁𝔂𝔃',
    fraktur: '𝔞𝔟𝔠𝔡𝔢𝔣𝔤𝔥𝔦𝔧𝔨𝔩𝔪𝔫𝔬𝔭𝔮𝔯𝔰𝔱𝔲𝔳𝔴𝔵𝔶𝔷',
    bold_fraktur: '𝖆𝖇𝖈𝖉𝖊𝖋𝖌𝖍𝖎𝖏𝖐𝖑𝖒𝖓𝖔𝖕𝖖𝖗𝖘𝖙𝖚𝖛𝖜𝖝𝖞𝖟',
    double_struck: '𝕒𝕓𝕔𝕕𝕖𝕗𝕘𝕙𝕚𝕛𝕜𝕝𝕞𝕟𝕠𝕡𝕢𝕣𝕤𝕥𝕦𝕧𝕨𝕩𝕪𝕫',
    sans_serif: '𝖺𝖻𝖼𝖽𝖾𝖿𝗀𝗁𝗂𝗃𝗄𝗅𝗆𝗇𝗈𝗉𝗊𝗋𝗌𝗍𝗎𝗏𝗐𝗑𝗒𝗓',
    bold_sans_serif: '𝗮𝗯𝗰𝗱𝗲𝗳𝗴𝗵𝗶𝗷𝗸𝗹𝗺𝗻𝗼𝗽𝗾𝗿𝘀𝘁𝘂𝘃𝘄𝘅𝘆𝘇',
    italic_sans_serif: '𝘢𝘣𝘤𝘥𝘦𝘧𝘨𝘩𝘪𝘫𝘬𝘭𝘮𝘯𝘰𝘱𝘲𝘳𝘴𝘵𝘶𝘷𝘸𝘹𝘺𝘻',
    bold_italic_sans_serif: '𝙖𝙗𝙘𝙙𝙚𝙛𝙜𝙝𝙞𝙟𝙠𝙡𝙢𝙣𝙤𝙥𝙦𝙧𝙨𝙩𝙪𝙫𝙬𝙭𝙮𝙯',
    monospace: '𝚊𝚋𝚌𝚍𝚎𝚏𝚐𝚑𝚒𝚓𝚔𝚕𝚖𝚗𝚘𝚙𝚚𝚛𝚜𝚝𝚞𝚟𝚠𝚡𝚢𝚣',
    regional_indicator: '🇦🇧🇨🇩🇪🇫🇬🇭🇮🇯🇰🇱🇲🇳🇴🇵🇶🇷🇸🇹🇺🇻🇼🇽🇾🇿',
    circle: 'ⓐⓑⓒⓓⓔⓕⓖⓗⓘⓙⓚⓛⓜⓝⓞⓟⓠⓡⓢⓣⓤⓥⓦⓧⓨⓩ',
    black_circle: '🅐🅑🅒🅓🅔🅕🅖🅗🅘🅙🅚🅛🅜🅝🅞🅟🅠🅡🅢🅣🅤🅥🅦🅧🅨🅩',
    square: '🄰🄱🄲🄳🄴🄵🄶🄷🄸🄹🄺🄻🄼🄽🄾🄿🅀🅁🅂🅃🅄🅅🅆🅇🅈🅉',
    parenthesized: '⒜⒝⒞⒟⒠⒡⒢⒣⒤⒥⒦⒧⒨⒩⒪⒫⒬⒭⒮⒯⒰⒱⒲⒳⒴⒵',
    fullwidth: 'ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ',
};

test('bold_serif Small (Fallback)', () => {
    expect(utd.decorate(testString, 'bold_serif')).toBe(correctAnswerSmallWithFallBack.bold_serif);
});

test('italic_serif Small (Fallback)', () => {
    expect(utd.decorate(testString, 'italic_serif')).toBe(correctAnswerSmallWithFallBack.italic_serif);
});

test('bold_italic_serif Small (Fallback)', () => {
    expect(utd.decorate(testString, 'bold_italic_serif')).toBe(correctAnswerSmallWithFallBack.bold_italic_serif);
});

test('script Small (Fallback)', () => {
    expect(utd.decorate(testString, 'script')).toBe(correctAnswerSmallWithFallBack.script);
});

test('bold_script Small (Fallback)', () => {
    expect(utd.decorate(testString, 'bold_script')).toBe(correctAnswerSmallWithFallBack.bold_script);
});

test('fraktur Small (Fallback)', () => {
    expect(utd.decorate(testString, 'fraktur')).toBe(correctAnswerSmallWithFallBack.fraktur);
});

test('bold_fraktur Small (Fallback)', () => {
    expect(utd.decorate(testString, 'bold_fraktur')).toBe(correctAnswerSmallWithFallBack.bold_fraktur);
});

test('double_struck Small (Fallback)', () => {
    expect(utd.decorate(testString, 'double_struck')).toBe(correctAnswerSmallWithFallBack.double_struck);
});

test('sans_serif Small (Fallback)', () => {
    expect(utd.decorate(testString, 'sans_serif')).toBe(correctAnswerSmallWithFallBack.sans_serif);
});

test('bold_sans_serif Small (Fallback)', () => {
    expect(utd.decorate(testString, 'bold_sans_serif')).toBe(correctAnswerSmallWithFallBack.bold_sans_serif);
});

test('italic_sans_serif Small (Fallback)', () => {
    expect(utd.decorate(testString, 'italic_sans_serif')).toBe(correctAnswerSmallWithFallBack.italic_sans_serif);
});


const correctAnswerSmall = {
    bold_serif: "𝐚𝐛𝐜𝐝𝐞𝐟𝐠𝐡𝐢𝐣𝐤𝐥𝐦𝐧𝐨𝐩𝐪𝐫𝐬𝐭𝐮𝐯𝐰𝐱𝐲𝐳",
    italic_serif: '𝑎𝑏𝑐𝑑𝑒𝑓𝑔ℎ𝑖𝑗𝑘𝑙𝑚𝑛𝑜𝑝𝑞𝑟𝑠𝑡𝑢𝑣𝑤𝑥𝑦𝑧',
    bold_italic_serif: '𝒂𝒃𝒄𝒅𝒆𝒇𝒈𝒉𝒊𝒋𝒌𝒍𝒎𝒏𝒐𝒑𝒒𝒓𝒔𝒕𝒖𝒗𝒘𝒙𝒚𝒛',
    script: '𝒶𝒷𝒸𝒹ℯ𝒻ℊ𝒽𝒾𝒿𝓀𝓁𝓂𝓃ℴ𝓅𝓆𝓇𝓈𝓉𝓊𝓋𝓌𝓍𝓎𝓏',
    bold_script: '𝓪𝓫𝓬𝓭𝓮𝓯𝓰𝓱𝓲𝓳𝓴𝓵𝓶𝓷𝓸𝓹𝓺𝓻𝓼𝓽𝓾𝓿𝔀𝔁𝔂𝔃',
    fraktur: '𝔞𝔟𝔠𝔡𝔢𝔣𝔤𝔥𝔦𝔧𝔨𝔩𝔪𝔫𝔬𝔭𝔮𝔯𝔰𝔱𝔲𝔳𝔴𝔵𝔶𝔷',
    bold_fraktur: '𝖆𝖇𝖈𝖉𝖊𝖋𝖌𝖍𝖎𝖏𝖐𝖑𝖒𝖓𝖔𝖕𝖖𝖗𝖘𝖙𝖚𝖛𝖜𝖝𝖞𝖟',
    double_struck: '𝕒𝕓𝕔𝕕𝕖𝕗𝕘𝕙𝕚𝕛𝕜𝕝𝕞𝕟𝕠𝕡𝕢𝕣𝕤𝕥𝕦𝕧𝕨𝕩𝕪𝕫',
    sans_serif: '𝖺𝖻𝖼𝖽𝖾𝖿𝗀𝗁𝗂𝗃𝗄𝗅𝗆𝗇𝗈𝗉𝗊𝗋𝗌𝗍𝗎𝗏𝗐𝗑𝗒𝗓',
    bold_sans_serif: '𝗮𝗯𝗰𝗱𝗲𝗳𝗴𝗵𝗶𝗷𝗸𝗹𝗺𝗻𝗼𝗽𝗾𝗿𝘀𝘁𝘂𝘃𝘄𝘅𝘆𝘇',
    italic_sans_serif: '𝘢𝘣𝘤𝘥𝘦𝘧𝘨𝘩𝘪𝘫𝘬𝘭𝘮𝘯𝘰𝘱𝘲𝘳𝘴𝘵𝘶𝘷𝘸𝘹𝘺𝘻',
    bold_italic_sans_serif: '𝙖𝙗𝙘𝙙𝙚𝙛𝙜𝙝𝙞𝙟𝙠𝙡𝙢𝙣𝙤𝙥𝙦𝙧𝙨𝙩𝙪𝙫𝙬𝙭𝙮𝙯',
    monospace: '𝚊𝚋𝚌𝚍𝚎𝚏𝚐𝚑𝚒𝚓𝚔𝚕𝚖𝚗𝚘𝚙𝚚𝚛𝚜𝚝𝚞𝚟𝚠𝚡𝚢𝚣',
    regional_indicator: 'abcdefghijklmnopqrstuvwxyz',
    circle: 'ⓐⓑⓒⓓⓔⓕⓖⓗⓘⓙⓚⓛⓜⓝⓞⓟⓠⓡⓢⓣⓤⓥⓦⓧⓨⓩ',
    black_circle: 'abcdefghijklmnopqrstuvwxyz',
    square: 'abcdefghijklmnopqrstuvwxyz',
    parenthesized: '⒜⒝⒞⒟⒠⒡⒢⒣⒤⒥⒦⒧⒨⒩⒪⒫⒬⒭⒮⒯⒰⒱⒲⒳⒴⒵',
    fullwidth: 'ａｂｃｄｅｆｇｈｉｊｋｌｍｎｏｐｑｒｓｔｕｖｗｘｙｚ',
};

test('bold_serif Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'bold_serif')).toBe(correctAnswerSmall.bold_serif);
});

test('italic_serif Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'italic_serif')).toBe(correctAnswerSmall.italic_serif);
});

test('bold_italic_serif Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'bold_italic_serif')).toBe(correctAnswerSmall.bold_italic_serif);
});

test('script Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'script')).toBe(correctAnswerSmall.script);
});

test('bold_script Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'bold_script')).toBe(correctAnswerSmall.bold_script);
});

test('fraktur Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'fraktur')).toBe(correctAnswerSmall.fraktur);
});

test('bold_fraktur Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'bold_fraktur')).toBe(correctAnswerSmall.bold_fraktur);
});

test('double_struck Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'double_struck')).toBe(correctAnswerSmall.double_struck);
});

test('sans_serif Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'sans_serif')).toBe(correctAnswerSmall.sans_serif);
});

test('bold_sans_serif Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'bold_sans_serif')).toBe(correctAnswerSmall.bold_sans_serif);
});

test('italic_sans_serif Small (No Fallback)', () => {
    expect(utd.decorate(testString, 'italic_sans_serif')).toBe(correctAnswerSmall.italic_sans_serif);
});